#delimit ;
version 8.0 ;
clear ;
set mem 400m ;
set more off ;
cap log close ;


****************************************************************
*
*     PROGRAMA PARA LA CONSTRUCCIÓN DEL ÍNDICE DE LA
*     TENDENCIA LABORAL DE LA POBREZA CON INTERVALOS DE SALARIOS
*
****************************************************************

Este programa debe ser utilizado con el Software Stata 
versión 8 o superior. 

Todas las bases de datos sociodemográficas de la Encuesta Nacional 
de Ocupación y Empleo (ENOE) pueden ser obtenidas en la página de 
Internet del INEGI, www.inegi.gob.mx.
Para esta estimación, de las bases de microdatos 
disponibles de la ENOE se emplean las siguientes: sdem.dta y coe2.dta.

En este programa se utilizan cuatro tipos de archivos, los cuales 
están ubicados en las siguientes carpetas:

1) Bases originales sociodemográficas: "C:\ITLP IS\sdem"
1) Bases originales cuestionario ocupación y empleo 2: "C:\ITLP IS\coe2"
2) Bases generadas: "C:\ITLP IS\temp"
3) Bitácoras: "C:\ITLP IS\log"

Para cambiar estas ubicaciones, se modifican los siguientes
globals; 

gl enoe = "C:\ITLP IS\sdem" ;
gl coe2 = "C:\ITLP IS\coe2";
gl temp = "C:\ITLP IS\temp" ;
gl log  = "C:\ITLP IS\log" ;

log using "$log\ITLP IS.smcl", replace ;

set obs 1 ;
gen periodo = . ;
gen TLP = . ;
save "$temp\Indice ESTADOS IS.dta", replace ;


*****************************************************************************

Parte I LÍNEA DE POBREZA EXTREMA POR INGRESOS :

***************************************************************************** ;


di in red "Promedio trimestral de los valores de la  
Línea de Pobreza Extrema por Ingresos" ;

scalar  uT105 = 712.54 ; 
scalar  rT105 = 492.78 ; 
scalar  uT205 = 741.49 ; 
scalar  rT205 = 520.05 ; 
scalar  uT305 = 740.37 ; 
scalar  rT305 = 516.84 ; 
scalar  uT405 = 736.48 ; 
scalar  rT405 = 510.03 ; 
     
scalar  uT106 = 754.24 ; 
scalar  rT106 = 526.53 ; 
scalar  uT206 = 748.55 ; 
scalar  rT206 = 518.10 ; 
scalar  uT306 = 764.24 ; 
scalar  rT306 = 533.35 ; 
scalar  uT406 = 797.76 ; 
scalar  rT406 = 565.69 ; 
     
scalar  uT107 = 814.70 ; 
scalar  rT107 = 576.48 ; 
scalar  uT207 = 803.92 ; 
scalar  rT207 = 563.70 ; 
scalar  uT307 = 810.79 ; 
scalar  rT307 = 567.70 ; 
scalar  uT407 = 830.52 ; 
scalar  rT407 = 582.76 ; 
     
scalar  uT108 = 839.18 ; 
scalar  rT108 = 585.91 ; 
scalar  uT208 = 858.24 ; 
scalar  rT208 = 601.28 ; 
scalar  uT308 = 875.52 ; 
scalar  rT308 = 614.67 ; 
scalar  uT408 = 906.75 ; 
scalar  rT408 = 640.53 ; 
     
scalar  uT109 = 922.00 ; 
scalar  rT109 = 649.04 ; 
scalar  uT209 = 949.84 ; 
scalar  rT209 = 672.97 ; 
scalar  uT309 = 967.60 ; 
scalar  rT309 = 686.43 ; 
scalar  uT409 = 968.90 ; 
scalar  rT409 = 686.09 ; 
     
scalar  uT110 = 992.68  ; 
scalar  rT110 = 705.17  ; 
scalar  uT210 = 987.38  ; 
scalar  rT210 = 695.86  ; 
scalar  uT310 = 979.48  ; 
scalar  rT310 = 684.99  ; 
scalar  uT410 = 1003.59 ; 
scalar  rT410 = 705.71  ; 
     
scalar  uT111 = 1021.50 ; 
scalar  rT111 = 717.40  ; 
scalar  uT211 = 1022.29 ; 
scalar  rT211 = 717.83  ; 
scalar  uT311 = 1023.17 ; 
scalar  rT311 = 716.93  ; 
scalar  uT411 = 1049.22 ; 
scalar  rT411 = 740.43  ; 
     
scalar  uT112 = 1079.48 ; 
scalar  rT112 = 765.39  ; 
scalar  uT212 = 1089.02 ; 
scalar  rT212 = 770.93  ; 
scalar  uT312 = 1130.09 ; 
scalar  rT312 = 805.72  ; 
scalar  uT412 = 1151.75 ; 
scalar  rT412 = 820.38  ; 
     
scalar  uT113 = 1166.22 ; 
scalar  rT113 = 828.61  ; 
scalar  uT213 = 1177.4  ; 
scalar  rT213 = 837.18  ; 
scalar  uT313 = 1177.99 ; 
scalar  rT313 = 833.37  ; 
scalar  uT413 = 1201.99 ; 
scalar  rT413 = 853.72  ; 
     
scalar  uT114 = 1234.8  ; 
scalar  rT114 = 870.81  ; 
scalar  uT214 = 1223.42 ; 
scalar  rT214 = 854.08  ; 
scalar  uT314 = 1243.83 ; 
scalar  rT314 = 869.82  ; 
scalar  uT414 = 1276.56 ; 
scalar  rT414 = 899.27  ; 
     
scalar  uT115 = 1264.53 ; 
scalar  rT115 = 896.17  ; 
scalar  uT215 = 1268.44 ; 
scalar  rT215 = 901.34  ; 
scalar  uT315 = 1282.51 ; 
scalar  rT315 = 911.38  ; 
scalar  uT415 = 1302.59 ; 
scalar  rT415 = 926.32  ; 
     
scalar  uT116 = 1338.64 ; 
scalar  rT116 = 959.7   ; 
scalar  uT216 = 1329.36 ; 
scalar  rT216 = 947.13  ; 
scalar  uT316 = 1323.88 ; 
scalar  rT316 = 942.81  ; 
scalar  uT416 = 1357.24 ; 
scalar  rT416 = 970.61  ; 
     
scalar  uT117 = 1376.88 ; 
scalar  rT117 = 975.82  ; 
scalar  uT217 = 1410.21 ; 
scalar  rT217 = 1003.88 ; 
scalar  uT317 = 1469.65 ; 
scalar  rT317 = 1053.26 ; 
scalar  uT417 = 1479.05 ; 
scalar  rT417 = 1054.84 ; 
     
scalar  uT118 = 1482.13 ; 
scalar  rT118 = 1052.56 ; 
scalar  uT218 = 1477.31 ; 
scalar  rT218 = 1046.25 ; 
scalar  uT318 = 1510.45 ; 
scalar  rT318 = 1068.21 ; 
scalar  uT418 = 1533.46 ;
scalar  rT418 = 1091.92 ;

*********************************************************

Parte II CÁLCULO DEL INGRESO DE LOS HOGARES :

********************************************************* ;

foreach x in T105 T205 T305 T405
		 T106 T206 T306 T406
		 T107 T207 T307 T407
		 T108 T208 T308 T408
		 T109 T209 T309 T409
		 T110 T210 T310 T410 
	     T111 T211 T311 T411
		 T112 T212 T312 T412	
		 T113 T213 T313 T413
		 T114 T214 T314 T414
		 T115 T215 T315 T415
		 T116 T216 T316 T416
		 T117 T217 T317 T417 
		 T118 T218 T318 T418{ ; 


use "$coe2\COE2`x'.dta" , clear;
tostring cd_a ent v_sel n_ren, replace format(%02.0f) force;
tostring con, replace format(%04.0f) force;
tostring  n_hog  h_mud  , replace force;

gen str foliop = (cd_a + ent + con + v_sel + n_hog + h_mud + n_ren);
keep foliop p6c p6b2 p6_9 p6a3;
sort foliop;

save "$temp\ingreso`x'.dta", replace;

use "$enoe\SDEM`x'.dta", clear ;
tostring cd_a  ent   v_sel n_ren, replace format(%02.0f) force;
tostring con, replace format(%04.0f) force;
tostring  n_hog  h_mud  , replace force;

keep if r_def==0 & (c_res==1 | c_res==3) ; 

gen str folioh = (cd_a + ent + con + v_sel + n_hog + h_mud);
gen str foliop = (cd_a + ent + con + v_sel + n_hog + h_mud+n_ren);

keep folioh foliop salario t_loc fac clase1 clase2 ent ingocup;
sort foliop;
merge foliop using "$temp\ingreso`x'.dta";
tab _merge;
drop _merge;

gen ocupado=cond(clase1==1 & clase2==1,1,0);

destring p6b2 p6c, replace;
recode p6b2 (999998=.) (999999=.);

*Recuperación de ingresos por rangos de salarios mínimos;
gen ingreso=p6b2;
replace ingreso=0 if ocupado==0;
replace ingreso=0 if p6b2==. & (p6_9==9 | p6a3==3);
replace ingreso=0.5*salario if p6b2==. & p6c==1;
replace ingreso=1*salario if p6b2==. & p6c==2;
replace ingreso=1.5*salario if p6b2==. & p6c==3;
replace ingreso=2.5*salario if p6b2==. & p6c==4;
replace ingreso=4*salario if p6b2==. & p6c==5;
replace ingreso=7.5*salario if p6b2==. & p6c==6;
replace ingreso=10*salario if p6b2==. & p6c==7;

gen tamh = 1 ; 
rename fac factor ;
gen rururb = cond(t_loc>=1 & t_loc<=3,0,1) ;
label define ru 0 "Urbano" 1 "Rural" ;
label values rururb ru ;
destring ent, replace;

gen mv=cond(ingreso==. & ocupado==1,1,0);

keep folioh tamh ingreso rururb factor ent mv ocupado;
collapse 
(sum) tamh ingreso mv ocupado (mean) rururb factor ent, 
by(folioh) ;

*Se elimina a los hogares que tienen valores perdidos en ingreso;

replace mv=1 if mv>0 & mv!=.;
drop if mv==1;

*******************************************************************

Parte III COMPARACIÓN DEL INGRESO DEL HOGAR CON EL PROMEDIO DE LA 
LINEA DE BIENESTAR MÍNIMO - LÍNEA DE POBREZA EXTREMA POR INGRESOS :

******************************************************************* ;

gen factorp = factor*tamh ;

gen lp`x' = cond(rururb==0,u`x',r`x') ;
gen pob = cond((ingreso/tamh)<lp`x',1,0) ;

sum pob [w=factorp] ;
gen TLP=r(mean)*100;
format TLP %6.4f;

sum pob [w=factorp] if rururb==0 ;
gen TLPu=r(mean)*100;
format TLPu %6.4f;

sum pob [w=factorp] if rururb==1 ;
gen TLPr=r(mean)*100;
format TLPr %6.4f;

foreach y in 1  2  3  4  5  6  7  8  9 10 
		11 12 13 14 15 16 17 18 19 20
		21 22 23 24 25 26 27 28 29 30 
		31 32 { ;

sum pob [w=factorp] if ent==`y' ;
gen TLP`y'=r(mean)*100;
format TLP`y' %6.4f;

};

gen periodo="`x'" ;

keep TLP* periodo;
keep in 1 ;

append using "$temp\Indice ESTADOS IS.dta";
save "$temp\Indice ESTADOS IS.dta", replace ;

} ;


*********************************************************

Parte IV CÁLCULO DEL ÍNDICE DE LA TENDENCIA 
	LABORAL DE LA POBREZA :

********************************************************* ;

drop if TLP==. ;
gen per=substr(periodo,2,3) ;
drop periodo ;
rename per periodo ;
destring periodo, replace ;
label var periodo "Trimestre" ;

sum TLP if periodo==110 ;
gen base=r(mean) ;
format base %6.4f ;
gen ITLP=. ;
replace ITLP=TLP/base ;
label var ITLP "Valor del índice de la tendencia laboral de la pobreza" ;
format ITLP %6.4f ;

sum TLPu if periodo==110 ;
gen baseu=r(mean) ;
format baseu %6.4f ;
gen ITLPu=. ;
replace ITLPu=TLPu/baseu ;
label var ITLPu "Valor del índice de la tendencia laboral de la pobreza urbano" ;
format ITLPu %6.4f ;

sum TLPr if periodo==110 ;
gen baser=r(mean) ;
format baser %6.4f ;
gen ITLPr=. ;
replace ITLPr=TLPr/baser ;
label var ITLPr "Valor del índice de la tendencia laboral de la pobreza rural" ;
format ITLPr %6.4f ;

foreach z in  1  2  3  4  5  6  7  8  9 10 
	     11 12 13 14 15 16 17 18 19 20
	     21 22 23 24 25 26 27 28 29 30 
	     31 32 { ;

sum TLP`z' if periodo==110 ;
gen base`z'=r(mean) ;
format base`z' %6.4f ;
gen ITLP`z'=. ;
replace ITLP`z'=TLP`z'/base`z' ;
label var ITLP`z' "Valor del índice de la tendencia laboral de la pobreza `z'" ;
format ITLP`z' %6.4f ;

};

gen orden=_n ;
gsort -orden ;
keep periodo ITLP*;

label define periodo
105 "I 2005"
205 "II 2005"
305 "III 2005"
405 "IV 2005"
106 "I 2006"
206 "II 2006"
306 "III 2006"
406 "IV 2006"
107 "I 2007"
207 "II 2007"
307 "III 2007"
407 "IV 2007"
108 "I 2008"
208 "II 2008"
308 "III 2008"
408 "IV 2008"
109 "I 2009"
209 "II 2009"
309 "III 2009"
409 "IV 2009"
110 "I 2010" 
210 "II 2010" 
310 "III 2010" 
410 "IV 2010"
111 "I 2011"
211 "II 2011"
311 "III 2011"
411 "IV 2011"
112 "I 2012"
212 "II 2012"
312 "III 2012"
313 "III 2013"
412 "IV 2012"
113 "I 2013"
213 "II 2013"
313 "III 2013"
413 "IV 2013"
114 "I  2014" 
214 "II 2014"
314 "III 2014"
414 "IV 2014" 
115 "I 2015"
215 "II 2015"
315 "III 2015"
415 "IV 2015"
116 "I 2016"
216 "II 2016"
316 "III 2016"
416 "IV 2016"
117 "I 2017"
217 "II 2017"
317 "III 2017"
417 "IV 2017"
118 "I 2018"
218 "II 2018"
318 "III 2018"
418 "IV 2018";

label value periodo periodo ;

rename ITLP Nacional ;
rename ITLPu Urbano ;
rename ITLPr Rural ;
rename ITLP1 Aguascalientes ;
rename ITLP2 Baja_California ;
rename ITLP3 Baja_California_Sur ;
rename ITLP4 Campeche ;
rename ITLP5 Coahuila ;
rename ITLP6 Colima ;
rename ITLP7 Chiapas ;
rename ITLP8 Chihuahua ;
rename ITLP9 Cuidad_de_México;
rename ITLP10 Durango ;
rename ITLP11 Guanajuato ;
rename ITLP12 Guerrero ;
rename ITLP13 Hidalgo ;
rename ITLP14 Jalisco ;
rename ITLP15 Estado_de_México ;
rename ITLP16 Michoacán ;
rename ITLP17 Morelos ;
rename ITLP18 Nayarit ;
rename ITLP19 Nuevo_León ;
rename ITLP20 Oaxaca ;
rename ITLP21 Puebla ;
rename ITLP22 Querétaro ;
rename ITLP23 Quintana_Roo ;
rename ITLP24 San_Luis_Potosí ;
rename ITLP25 Sinaloa ;
rename ITLP26 Sonora ;
rename ITLP27 Tabasco ;
rename ITLP28 Tamaulipas ;
rename ITLP29 Tlaxcala ;
rename ITLP30 Veracruz ;
rename ITLP31 Yucatán ;
rename ITLP32 Zacatecas ;

tabstat  Nacional- Zacatecas, by (per) format(%6.2f) nototal;
save "$temp\ITLP IS.dta", replace ;
scalar list;

log close ;
